# fdm_a
    include fdm.h

    subroutine admit(f,mode)
    #implicit undefined(a-z)
    complex zf,zme,zhe,ht
    complex cpadmit
    integer mode, i
    real x,f
    real xinterp,ag,tpi,xol,ac,rf
    include carrays
    include cparms
    include cucon
    data tpi/6.2832/

    s=cmplx(0.,tpi*f)
    dx=xl/(n-1)
    srd=2*s*rho*dx
    ht=(vihc+dihc*s)

    # Middle-ear

    if (midear) {
	ped=2.828e-4       # eardrum pressure (dyn/cm**2 peak) 
			   # = 20 micropascal rms = 0 dB SPL.
	ag = ast*gmel
	zme = mst*s+rst+kst/s
	yme = (ag*ag)/zme
	pme = ped*(ama/ag)
	}
    else {
	dst=1.e-10         # stapes displacement (cm peak) = me.
	yme = 0.
	pme = s*srd*dst
	}

    # Helicotrema

    zhe = rhe
    yhe = 1/zhe

    # Cochlear partition

    y(1)=0
    for(i=2; i<=n; i=i+1){
	x = (i-1)*dx+xoff
	y(i) = cpadmit(f,x,mode)
	}

    # scala fluid

    for(i=1; i<=n; i=i+1){
	x = (i-1)*dx+xoff
	xol = x/xl
	ac=xinterp(xol,aca,acb,acc)
	rf=xinterp(xol,rfa,rfb,rfc)
	zf = (rf+(2*rho/ac)*s)*dx
	yf(i) = 1/zf
	}

    return
    end

complex function cpadmit(f,x,mode)
    #implicit undefined(a-z)
    complex z1,z2,z3,yp,zp,hohc,hihc,ha,ht,h1,h2,yy,hr
    integer mode, i
    real t1, t2, gb, g1, g2, k1, k2, k3, m1, m2, r1, r2, r3
    real x,f,bw,gp,ap
    real xinterp,tpi,xol
    include carrays
    include cparms
    include cucon
    data tpi/6.2832/

    s=cmplx(0.,tpi*f)
    srd=2*s*rho*dx
    ht=(vihc+dihc*s)
    xol=x/xl

    # Cochlear partition

    bw=xinterp(xol,bwa,bwb,bwc)
    g1=xinterp(xol,g1a,g1b,g1c)
    g2=xinterp(xol,g2a,g2b,g2c)
    gb=xinterp(xol,gba,gbb,gbc)
    gp=xinterp(xol,gpa,gpb,gpc)
    k1=xinterp(xol,k1a,k1b,k1c)
    k2=xinterp(xol,k2a,k2b,k2c)
    k3=xinterp(xol,k3a,k3b,k3c)
    m1=xinterp(xol,m1a,m1b,m1c)
    m2=xinterp(xol,m2a,m2b,m2c)
    r1=xinterp(xol,r1a,r1b,r1c)
    r2=xinterp(xol,r2a,r2b,r2c)
    r3=xinterp(xol,r3a,r3b,r3c)
    t1=xinterp(xol,t1a,t1b,t1c)
    t2=xinterp(xol,t2a,t2b,t2c)
    ap=bw*dx
    z1=k1/s+r1+m1*s
    z2=k2/s+r2+m2*s
    z3=k3/s+r3
    h1=g1/(1+t1*s)
    h2=g2/(1+t2*s)
    ha=gam*h1*h2
    hohc=gp/(1+gp*ha+z3/z2)
    zp=(z1+gp*hohc*z3)/ap	# assumes z1,z2,z3 are per unit area
    hr=gp*(1-ha*hohc)
    hihc=(1+(1-gb)*gp*ha)*hohc
    if (i==1)
	yp=0
    else if (i==n)
	yp=yhe
    else
	yp=1/zp
    if(mode==0)
	yy=yp				# partition
    else if(mode==1)
	yy=(yp/ap)			# basilar membrane
    else if(mode==2)
	yy=(yp/ap)*(hohc)		# OHC cilia
    else if(mode==3)
	yy=(yp/ap)*(hihc/ht)		# IHC cilia
    else if(mode==4)
	yy=ha				# OHC gain
    else if(mode==5)
	yy=hihc				# IHC transduction gain
    else if(mode==6)
	yy=hohc				# OHC transduction gain
    else if(mode==7)
	yy=h1				# OHC forward transduction
    else if(mode==8)
	yy=h2				# OHC reverse transduction
    else if(mode==9)
	yy=(yp/ap)*(hohc*h1/s)		# OHC membrane potential
    else if(mode==10)
	yy=(yp/ap)*(hohc*ha)		# OHC contraction
    else if(mode==11)
	yy=(yp/ap)*(hihc)		# IHC cilia velocity
    else if(mode==12)
	yy=hr				# ratio xir to xib
    else if(mode==13)
	yy=hohc*(z3/z2)/hr		# ratio xit to xir
    else
	yy=0

    return (yy)
    end

# wrimpd - write impedance to data file

subroutine wrimpd
    #implicit undefined(a-z)
    character*20 file
    complex z(Nmax)
    integer i,j
    real f,zrmn
    include carrays
    include cparms
    include cucon

    f = freq(1)
    call admit(f,0)
    zrmn = 0
    j = 0
    do i=2,n {
	z(i) = 1/y(i)
	if (zrmn > real(z(i))) {
	    zrmn = real(z(i))
	    j = i
	    }
	}
    write(*,*)'max. neg. imp. =',zrmn,' at x =',(j-1)*dx,' cm'
    file = 'imped_ri.dat'
    open(unit=DATAOUT3, file=file, status='unknown', form='formatted', err=1)
    write(DATAOUT3, 201)f
    write(DATAOUT3, 202)
    write(DATAOUT3, 203)((i-1)*dx, real(1/y(i)), imag(1/y(i)), i = 2, n)
    close(DATAOUT3)
    file = 'imped_mp.dat'
    open(unit=DATAOUT3, file=file, status='unknown', form='formatted', err=1)
    write(DATAOUT3, 204)f
    write(DATAOUT3, 205)
    write(DATAOUT3, 206)((i-1)*dx, 20*log10(cabs(1/y(i))),
	atan2(imag(1/y(i)), real(1/y(i))), i = 2, n)
    close(DATAOUT3)
    return
    1 write(ERROUT, *)'can''t open: ', file
    call exit(1)
    201 format('; imped_ri.dat - impedance from fdm_a, freq = ', f9.0)
    202 format('; x, Re{y(x)}, Im{y(x)}')
    203 format(3g15.6)
    204 format('; imped_mp.dat - impedance from fdm_a, freq = ', f9.0)
    205 format('; x, log|y(x)|, ang{y(x)}')
    206 format(3g15.6)
    end

real function xinterp(x,a,b,c)
    #implicit undefined(a-z)
    real x,a,b,c,al,bl,cl,xl

    if (a > 0)
	al=log(a)
    else
	al=-100
    if (b > 0)
	bl=log(b)
    else
	bl=-100
    if (c > 0)
	cl=log(c)
    else
	cl=-100
    xl = al + (4*bl-3*al-cl)*x + (2*al-4*bl+2*cl)*x**2
    return (exp(xl))
    end
