# fdm_b - finite difference frequency domain model, part b
    include fdm.h

    subroutine fdmodl(fr)
    complex ytmp
    include cio
    include carrays
    include cucon
    include cparms

    call admit(fr,0)

    # rigid basal boundary
    ytmp=yf(1)+yme
    a(1)=-yf(1)/ytmp
    p(1)=-pme*yme/ytmp

    for(k=2; k<=n-1; k=k+1){	# from base to apex
        ytmp=yf(k)+y(k)+yf(k-1)*(1+a(k-1))
	a(k)=-yf(k)/ytmp
	p(k)=p(k-1)*yf(k-1)/ytmp
	}

    ytmp=yhe+yf(n-1)*(1+a(n-1))	# apex
    p(n)=p(n-1)*yf(n-1)/ytmp

    for(k=n-1; k>=1; k=k-1)	# from apex to base
	p(k)=p(k)-a(k)*p(k+1)

    return
    end

