# fdmbd - initialize common blocks
    include fdm.h

    block data fdmbd
    include cparms
    include cio

    data iconsl/ERROUT/
    data input/STDIN/
    data vernum,revnum/VERNUM,REVNUM/
    data m/1/	     		# number of points in z
    data n/256/		   	# number of points in x
    data ppo/16/     		# points per octave
    data dihc/1./	  	# IHC displacement
    data vihc/0./	  	# IHC velocity
    data rho/1./	  	# fluid density, gm/cm**3
    data css/1.54e5/		# speed of sound, cm/sec.
    data fpma,fpmb,fpmc/0.456,0.021,0.80/	# cat map from Liberman (1982)
    data mco/.05/
    data rco/120./
    data rve/60./
    data rfa,rfb,rfc/.01,.01,.01/	# damping component of fluid
    data aca,acb,acc/.01,.01,.01/	# scala cross-section area
    data xl/2.55/	 	# length of the cochlea in x
    data yw/.1/	   		# width  of the cochlea in y
    data zh/.1/		   	# height of the cochlea in z
    data bwa,bwb,bwc/.01,.01,.01/	# BM width
    data gpa,gpb,gpc/1.,1.,1./		# BM to IHC lever gain
    data gam/1./		# normal OHC transduction gain
    data gamuns/1.2/		# unstable OHC transduction gain
    data xoff/0./		# x position offset
    data alo,ale/1.,0./		# OHC contribution to TM-RL shear
    data k1a,k1b,k1c/1e8,1e7,1e6/	# stiffness component of Z1
    data r1a,r1b,r1c/100.,100.,100./	# damping component of Z1
    data m1a,m1b,m1c/.1,.1,.1/		# mass component of Z1
    data k2a,k2b,k2c/1e7,1e6,1e5/	# stiffness component of Z2
    data r2a,r2b,r2c/40.,40.,40./	# damping component of Z2
    data m2a,m2b,m2c/.1,.1,.1/		# mass component of Z2
    data k3a,k3b,k3c/1e7,1e6,1e5/	# stiffness component of Z3
    data r3a,r3b,r3c/40.,40.,40./	# damping component of Z3
    #data k4o,k4e/4.e7,-4./	# stiffness component of Z4
    #data r4o,r4e/40.,-.8/	# damping component of Z4
    data g1a,g1b,g1c/0.,0.,0./		# OHC forward transduction (V/cm)
    data g2a,g2b,g2c/0.,0.,0./		# OHC reverse transduction (cm/V)
    data gba,gbb,gbc/1e9,1e9,1e9/	# OHC LF gain
    data t1a,t1b,t1c/0.,0.,0./		# OHC time constant (sec)
    data t2a,t2b,t2c/0.,0.,0./		# OHC time constant (sec)
    data midear/.true./		# stimulus passes through middlea.   
    data basacc/.true./		# rigid boundary at base.
    data kst/5.e5/		# stiffness of stapes attachmen yc
    data rst/40./	 	# damping of stapes
    data mst/.005/		# mass of stapes
    data ast/.01/	 	# effective area of stapes footaec*.   
    data kma/4.e5/		# stiffness of malleus attachme,d/.   
    data rma/60./	 	# damping of malleus attachment ne/.   
    data mma/.01/		# effecti   
    data ama/.35/	 	# effective ae  eadmc*.   
    data kim/4.e7/		# stiffness of incudo-malleolaron nm
    data rim/400./		# damping of incudo-malleolar jn,yscm   
    data gmel/0.5/		# gain of middle ear lever.
    #data nf,freq/1,25600.,15*0./
    data nf,freq/4,400.,1600.,6400.,25600.,12*0./
    data phfs/31.42,31.42,31.42/
    data dbfs/100.,100.,100./
    data phmx/3.142,3.142,3.142/
    data dbmx/-20.,-140.,-140./
    data laba/' -20      pressure'/
    data labb/'-140  bm displacement'/
    data labc/'-140  ihc displacement'/
    data title/'pressure source fdm'/
    end
