# fig6 - make fig 6 data files
    include fdm.h

    subroutine fig6
    call fig6f(.02,50.,'f6a-1.dat','f6b-1.dat')
    #call lynchzc(.02,50.,'f6a_1.dat','f6b_1.dat')
    return
    end

# fig6f

    subroutine fig6f(f1,f2,file1,file2)
    character*(*) file1,file2
    complex vs,zpc
    integer opnfil
    include carrays
    include cucon
    include cparms
    include cio
    data tpi/6.2832/

    if(opnfil(1,file1,'formatted')==EOF) return
    if(opnfil(2,file2,'formatted')==EOF) return
    call fdate(date)
    write(1,201)file1,f1,f2,date
    write(2,201)file2,f1,f2,date
    frat=2.**(1./ppo)
	
    db0=120.
    for(f=f1; f<=f2; f=f*frat){
	fhz=f*1000.
	call fdmodl(fhz)
	vs = yf(1)*(p(1)-p(2))		# volume velocity at stapes
	zpc =  p(1)/vs			# cochlear input impedance
	zpcm=cabs(zpc)*1.e-6
	zpcp=atan2(aimag(zpc),real(zpc))*360./tpi
	write(1,202)f,zpcm
	write(2,203)f,zpcp
	}
    close(1)
    close(2)
    return
    201 format(' ; ',a,' - "Zpc vs. f"',
	      /' ;      f =',f8.3,' to',f8.3,' kHz',
	      /' ; ',a/' ; ')
    202 format(' ',f8.4,', ',f8.2)
    203 format(' ',f8.4,', ',f8.3)
    end

# lynchzc

    subroutine lynchzc(f1,f2,file1,file2)
    character*(*) file1,file2
    complex s,zpc
    integer opnfil
    include cparms
    data tpi/6.2832/
    data rc,ro,mo/1.2e6,0.28e6,2250./

    if(opnfil(1,file1,'formatted')==EOF) return
    if(opnfil(2,file2,'formatted')==EOF) return
    call fdate(date)
    write(1,201)file1,f1,f2,date
    write(2,201)file2,f1,f2,date
    frat=2.**(1./ppo)
	
    for(f=f1; f<=f2; f=f*frat){
	fhz=f*1000.
	s=cmplx(0,tpi*fhz)
	zpc=1/(1/rc+1/(mo*s+ro))	# cochlear input impedance
	zpcm=cabs(zpc)*1.e-6
	zpcp=atan2(aimag(zpc),real(zpc))*360./tpi
	write(1,202)f,zpcm
	write(2,203)f,zpcp
	}
    close(1)
    close(2)
    return
    201 format(' ; ',a,' - "Zpc vs. f, from Lynch, et al., 1982"',
	      /' ;      f =',f8.3,' to',f8.3,' kHz',
	      /' ; ',a/' ; ')
    202 format(' ',f8.4,', ',f8.2)
    203 format(' ',f8.4,', ',f8.3)
    end
