# fig7 - make fig 7 data files
    include fdm.h

    subroutine fig7
    include cparms

    call fig7f(.02,50.,'f7a-1.dat','f7b-1.dat')
    return
    end

# fig7f

    subroutine fig7f(f1,f2,file1,file2)
    character*(*) file1,file2
    complex pr
    integer opnfil
    include carrays
    include cucon
    include cparms
    include cio
    data tpi/6.2832/

    if(opnfil(1,file1,'formatted')==EOF) return
    if(opnfil(2,file2,'formatted')==EOF) return
    call fdate(date)
    write(1,201)file1,f1,f2,date
    write(2,201)file2,f1,f2,date
    frat=2.**(1./ppo)
	
    db0=120.
    phr=0
    for(f=f1; f<=f2; f=f*frat){
	fhz=f*1000.
	call fdmodl(fhz)
	pr = -p(1) / ped
	prm=20*log10(cabs(pr))
	prp=atan2(aimag(pr),real(pr))*360./tpi
	prp=prp+360*nint((phr-php)/360)
	write(1,202)f,prm
	write(2,203)f,prp
	phr=prp
	}

    close(1);
    close(2);

    return
    201 format(' ; ',a,' - "Zpc vs. f"',
	      /' ;      f =',f8.3,' to',f8.3,' kHz',
	      /' ; ',a/' ; ')
    202 format(' ',f8.4,', ',f8.2)
    203 format(' ',f8.4,', ',f8.3)
    end
