# fig8 - make fig 8 data files
    include fdm.h

subroutine fig8
    call zerph
    call fig8f(.1,50.,
		place(0.25),'f8b-1.dat',
		place(1.00),'f8b-2.dat',
		place(4.00),'f8b-3.dat',
		place(16.0),'f8b-4.dat')
    call fig8f(.1,50.,
		place(0.50),'f8b-5.dat',
		place(2.00),'f8b-6.dat',
		place(8.00),'f8b-7.dat',
		place(32.0),'f8b-8.dat')
    return
    end

# fig8f

subroutine fig8f(f1,f2,po1,fi1,po2,fi2,po3,fi3,po4,fi4)
    character*(*) fi1,fi2,fi3,fi4
    integer opnfil,ipo(4)
    include carrays
    include cucon
    include cparms
    include cio
    #data ppo/16./

    if(opnfil(1,fi1,'formatted')==EOF) return
    if(opnfil(2,fi2,'formatted')==EOF) return
    if(opnfil(3,fi3,'formatted')==EOF) return
    if(opnfil(4,fi4,'formatted')==EOF) return
    call fdate(date)
    write(1,201)fi1,po1,f1,f2,date
    write(2,201)fi2,po2,f1,f2,date
    write(3,201)fi3,po3,f1,f2,date
    write(4,201)fi4,po4,f1,f2,date
    frat=2.**(1./ppo)
    ipo(1)=1+(n-1)*po1
    ipo(2)=1+(n-1)*po2
    ipo(3)=1+(n-1)*po3
    ipo(4)=1+(n-1)*po4
    #db0=-140	# 1 nm iso-displacement
    #db0=-60	# 0.01 mm/s iso-displacement
    db0=0	# reference determined by parameters
    for(f=f1; f<=f2; f=f*frat){
	fhz=f*1000.
	call fdmodl(fhz)
	# hc displacement
	call admit(fhz,3)	# IHC cilia
	for(i=1; i<=4; i=i+1)
	    a(i)=y(ipo(i))*p(ipo(i))
	call dbph(a,4)
	for(i=1; i<=4; i=i+1) {
	    db=db0-real(a(i))
	    write(i,202)f,db
	    }
	}

    close(1);
    close(2);
    close(3);
    close(4);

    return
    201 format(' ; ',a,' - "xih vs. f"   at (x/L) =',f6.2,
	      /' ;      f =',f8.3,' to',f8.3,' kHz',
	      /' ; ',a/' ; ')
    202 format(' ',f8.4,', ',f8.2)
    203 format(' ',f8.4,', ',f8.3)
    end

real function place(cf)
    real cf,xol
    include cparms

    xol = 1 - log10(cf/fpma+fpmc)/(100*fpmb)
    return(xol)
    end
