# fig9 - make fig 9 data files
    include fdm.h

subroutine fig9
    call zerph
    call fig9f(.04,30.,place(16.6),place(7.0),place(2.8),place(1.1))
    return
    end

# fig9

subroutine fig9f(f1,f2,po1,po2,po3,po4)
    character*20 fi1a,fi1b,fi2a,fi2b,fi3a,fi3b,fi4a,fi4b
    real pe(4),lp(4),lf
    integer opnfil,ipo(4)
    include carrays
    include cucon
    include cparms
    include cio
    #data ppo/16./

    #if(opnfil(1,'lab9m.plt','formatted')==EOF) return
    #write(1,200)int(vihc*10000*2)
    #close(1)

    fi1a = 'f9a-1.dat'
    fi2a = 'f9a-2.dat'
    fi3a = 'f9a-3.dat'
    fi4a = 'f9a-4.dat'
    fi1b = 'f9b-1.dat'
    fi2b = 'f9b-2.dat'
    fi3b = 'f9b-3.dat'
    fi4b = 'f9b-4.dat'
    if(opnfil(1,fi1a,'formatted')==EOF) return
    if(opnfil(2,fi2a,'formatted')==EOF) return
    if(opnfil(3,fi3a,'formatted')==EOF) return
    if(opnfil(4,fi4a,'formatted')==EOF) return
    if(opnfil(5,fi1b,'formatted')==EOF) return
    if(opnfil(6,fi2b,'formatted')==EOF) return
    if(opnfil(7,fi3b,'formatted')==EOF) return
    if(opnfil(8,fi4b,'formatted')==EOF) return
    call fdate(date)
    write(1,201)fi1a,po1,f1,f2,date
    write(2,201)fi2a,po2,f1,f2,date
    write(3,201)fi3a,po3,f1,f2,date
    write(4,201)fi4a,po4,f1,f2,date
    write(5,201)fi1b,po1,f1,f2,date
    write(6,201)fi2b,po2,f1,f2,date
    write(7,201)fi3b,po3,f1,f2,date
    write(8,201)fi4b,po4,f1,f2,date
    frat=2.**(1./ppo)
    ipo(1)=1+(n-1)*po1
    ipo(2)=1+(n-1)*po2
    ipo(3)=1+(n-1)*po3
    ipo(4)=1+(n-1)*po4
    #db0=-140	# 1 nm iso-displacement
    #db0=-48	# 0.04 mm/s iso-velocity
    #db0=0	# reference determined by parameters
    db0=6	# reference determined by parameters + 6 dB
    for(f=f1; f<=f2; f=f*frat){
	fhz=f*1000.
	call fdmodl(fhz)
	# hc displacement
	call admit(fhz,3)	# IHC cilia
	for(i=1; i<=4; i=i+1)
	    a(i)=y(ipo(i))*p(ipo(i))
	call dbph(a,4)
	for(i=1; i<=4; i=i+1) {
	    pe(i)=db0-real(a(i))
	    write(i,202)f,pe(i)
	    }
	if (f > f1) {
	    for(i=1; i<=4; i=i+1) {
		if (pe(i) < 90 && pe(i) > 0) {
		    gd=grpd(a,lp,f,lf,i)
		    write(4+i,202)f,gd
		    }
		}
	    }
	lf = f
	for(i=1; i<=4; i=i+1)
	    lp(i) = aimag(a(i))
	}

    close(1);
    close(2);
    close(3);
    close(4);
    close(5);
    close(6);
    close(7);
    close(8);

    return
    200 format('"^j^[b] =',i3,' ^m^m/sec"')
    201 format('; ',a,' - "xih vs. f"   at (x/L) =',f6.2,
	      /';      f =',f8.3,' to',f8.3,' kHz',
	      /'; ',a/'; ')
    202 format(' ',f8.4,', ',f8.2)
    203 format(' ',f8.4,', ',f8.3)
    end

    real function grpd(a,lp,f,lf,i)
    complex a(*)
    real lp(*),lf
    data pi/3.1415927/

    phd = lp(i) - aimag(a(i))
    while (phd > pi)
	phd = phd - 2 * pi
    while (phd < -pi)
	phd = phd + 2 * pi
    return (phd/(2*pi*(f - lf)))
    end
